/**
 * 2007-2022 PrestaShop and Contributors
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Academic Free License 3.0 (AFL-3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * https://opensource.org/licenses/AFL-3.0
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * @author    PrestaShop SA <contact@prestashop.com>
 * @copyright 2007-2022 PrestaShop SA and Contributors
 * @license   https://opensource.org/licenses/AFL-3.0 Academic Free License 3.0 (AFL-3.0)
 * International Registered Trademark & Property of PrestaShop SA
 */
var chekarray = [];
var albarray = [];
var arrayRemitentes;
var arrayServicios;
var arrayEstados;
var arrayDocumentado;
var arrayReparto;
var arrayEntregado;
var arrayCarrier;
var conta = 0;


/*===================================================================================
		 Definimos la Librería JQUERY al cargar el documento.
===================================================================================*/

jQuery(document).ready(function(){

	
	
	
	var link = $(location).attr('href');
	let termino = "sendingbay";
	let urlCongig = link.indexOf(termino);
 
	if(urlCongig > -1 && localStorage.getItem("urlConfig") == null){
	 localStorage.setItem("urlConfig", link);
	}
	if(localStorage.getItem("urlConfig") != null){
	 $('#subtab-AdminUbilopFact a').attr('href', localStorage.getItem("urlConfig"));
	 $('#subtab-AdminFactDatos a').attr('href', localStorage.getItem("urlConfig"));
	}else{

	}
 
	let tiempo = Date.now();
	let hoy = new Date(tiempo);
	let mes = hoy.getMonth()+1;
 
	if(mes.toString().length == 1)   
	mes = '0'+mes;
 
	let hoy1 = hoy.getDate()
	if(hoy1.toString().length == 1)  
	hoy1= '0'+hoy1;

	$('#fechaDesdeP').val(hoy.getFullYear()+"-"+mes+"-"+hoy1);
	$('#fechaHastaP').val(hoy.getFullYear()+"-"+mes+"-"+hoy1);
 
	$('#fechaDesde').val(hoy.getFullYear()+"-"+mes+"-"+hoy1);
	$('#fechaHasta').val(hoy.getFullYear()+"-"+mes+"-"+hoy1);

	$('#fechaDesdeD').val(hoy.getFullYear()+"-"+mes+"-"+hoy1);
	$('#fechaHastaD').val(hoy.getFullYear()+"-"+mes+"-"+hoy1);
	//console.log(hoy.getFullYear()+"-"+mes+"-"+hoy1);
 
	$( "#sltDocumentado" ).change(function() {
	 $('.documentado').val($('#sltDocumentado').val());
	});
 
	$( "#sltReparto" ).change(function() {
	 $('.reparto').val($('#sltReparto').val());
	});
 
	$( "#sltEntregado" ).change(function() {
	 $('.entregado').val($('#sltEntregado').val());
	});

	$( "#sltServicio" ).change(function() {
		$('#servicio').val($('#sltServicio').val());
		$('#sltServicio').val($('#servicio').val());
	});

	$( ".servicio1" ).change(function() {
		$('#servicio').val($('.servicio1').val());
		$('#sltServicio').val($('#servicio').val());
	});

	$( "#sltCarrier" ).change(function() {
		$('.carrier').val($('#sltCarrier').val());
	});

	/**
	 *  
	 */
	/*===================================================================================
		 Ejecutamos el evento keyup en los campos del formulario de la cofiguración.
	 ===================================================================================*/
	$('.urlWS').on('keyup', function(e) {

		/*e.preventDefault();
		let url = $(this).val();
		var pos = url.indexOf("FACTWS");
		let iris = url.substring(0, pos);
		$('.urlIris').val(iris+'Iris/Seguimiento?s=');
		*/
	})

	$('.urlIris').on('click', function(e) {

		e.preventDefault();
		let url = $('.urlWS').val();
		if(url != ''){
		var pos = url.indexOf("FACTWS");
		let iris = url.substring(0, pos);
		$('.urlIris').val(iris+'Iris/Seguimiento?s=');
		}else{
			alert('Debe ingresar la URL del WebService');
		}

	})

	$('.txtUsuario').on('keyup', function(e) {

		e.preventDefault();
		let usuario = $(this).val();
		$('.txtUsuario').val(usuario);

	})
	$('.txtClave').on('keyup', function(e) {

		e.preventDefault();
		let clave = $(this).val();
		$('.txtClave').val(clave);

	})
	$('.urlWS').on('keyup', function(e) {

		e.preventDefault();
		let ws = $(this).val();
		$('.urlWS').val(ws);

	})
	$('.departamento').on('keyup', function(e) {
		e.preventDefault();
		let departamento = $(this).val();
		$('.departamento').val(departamento);

	})

	$('.txtServicio').on('keyup', function(e) {

		e.preventDefault();
		let servicio = $(this).val();
		$('.txtServicio').val(servicio);

	})
	$('.txtNombre').on('keyup', function(e) {

		e.preventDefault();
		let nombre = $(this).val();
		$('.txtNombre').val(nombre);

	})
	$('.txtDireccion').on('keyup', function(e) {

		e.preventDefault();
		let direccion = $(this).val();
		$('.txtDireccion').val(direccion);

	})
	$('.txtPoblacion').on('keyup', function(e) {

		e.preventDefault();
		let poblacion = $(this).val();
		$('.txtPoblacion').val(poblacion);

	})
	$('.txtCodPostal').on('keyup', function(e) {

		e.preventDefault();
		let codPostal = $(this).val();
		$('.txtCodPostal').val(codPostal);

	})
	$('.txtPais').on('focusout', function(e) {

		e.preventDefault();
		let pais = $(this).val();
		let pais1 = pais.substring(0,  3);
		$('.txtPais').val(pais1);

	})
	$('.txtTelefono').on('keyup', function(e) {

		e.preventDefault();
		let telefono = $(this).val();
		$('.txtTelefono').val(telefono);

	})
	
	$('.txtEmail').on('keyup', function(e) {

		e.preventDefault();
		let email = $(this).val();
		$('.txtEmail').val(email);

	})
	$('.txtContacto').on('keyup', function(e) {

		e.preventDefault();
		let contacto = $(this).val();
		$('.txtContacto').val(contacto);

	})

	 //función que filtra los resultados de envios transmitidas por palabras claves
	 $('#buscarP').on('keyup', function(e) {
		e.preventDefault();
		var value = $(this).val().toLowerCase();
		$('#tblPedidos tr').filter( function() {

			$(this).toggle($(this).text().toLowerCase().indexOf(value) > -1)
			
		});	
	})

	 //función que filtra los resultados de envios transmitidas por palabras claves
	 $('#buscar').on('keyup', function(e) {
		e.preventDefault();
		var value = $(this).val().toLowerCase();
		$('#tblOrdenes tr').filter( function() {

			$(this).toggle($(this).text().toLowerCase().indexOf(value) > -1)
			
		});	
	})

	//función que filtra los resultados de recogidas transmitidas por palabras claves
	$('#buscarD').on('keyup', function(e) {
		e.preventDefault();
		var value = $(this).val().toLowerCase();
		$('#tblOrdenesD tr').filter( function() {

			$(this).toggle($(this).text().toLowerCase().indexOf(value) > -1)
			
		});	
	})


	/*==============================================================================================================================================================
		 // Actualizador de estados automatico al cargar la pagina, antes de actualizar se verifica si se ha cumplido el intervalo de tiempo de ejecución configurado
	 ===================================================================================================================================================================*/
 
	actualizarEstados();	
	function actualizarEstados(){
		
		$.ajax({
		 url: baseDir + 'modules/sendingbay/ajax.php',
		 type: 'POST',
		 dataType: 'json',
		 data : {
			 action: 'updateState'
		 }, success: function( data ){
			 
			//console.log(data.result.length)
 
		 }, error: function( d,x,v ) {
		 
			 console.log(d);
			 console.log(x);
			 console.log(v);
			 
		 }
	 });
		
	}
	
 
	
	/*===================================================================================
			 en caso de no recargar la pagina el actualizador se ejecuta cada 5 horas
	 ===================================================================================*/
	setInterval(function(){
	 actualizarEstados();
   },16600000);

   /*===================================================================================
			 Configuracón de estilos para los botones de las tareas programadadas CRON
	 ===================================================================================*/

   $('.btnpConfig').on( 'click', function(e){ 

		e.preventDefault();
		$('.btnGuardar').attr('style', 'display:block');
		$('.remitentegs').attr('style', 'display:none');
   });

   $('.btnpRemi').on( 'click', function(){ 
		$('.btnGuardar').attr('style', 'display:none');
		$('.remitentegs').attr('style', 'display:block');
   });

   $('.btnpCron').on( 'click', function(){ 
		$('.btnGuardar').attr('style', 'display:block');
		$('.remitentegs').attr('style', 'display:none');
	});

	$('.verPass').on('click', function(){

		if($('.txtClave').attr('type') == "password"){
			$('.txtClave').attr('type', 'text');
		}else{
			$('.txtClave').attr('type', 'password');
		}
	});


	/*===================================================================================
	dd/mm/yyyy	Función que permite la carga de los datos de la empresa en el formulario de configuración
	 ===================================================================================*/

	 $(document).on( 'click', '[data-get-fact-credentials]', function(e){

	   e.preventDefault();
	   $(this).attr('disabled', true);
	   $.ajax({
		   url: baseDir + 'modules/sendingbay/ajax.php',
		   type: 'POST',
		   dataType: 'json',
		   data : {
			   action: 'factCredentials',
			   tipo: 'view'
		   }, success: function( data ){
			   console.log(data);

			   if(data){

				   $('.get-fact-credentials').attr('disabled', false);

				   Swal.fire({
					   title   : 'Petición exitosa '+ data.success,
					   text    : 'Solicitud recibida, en breve nos comunicaremos con usted.  ' ,
					   icon    : 'success'
				   });
			   }
			   
			   
		   }, error: function( d,x,v ) {

			   console.log(d);
			   console.log(x);
			   console.log(v);

		   }
	   });

   });


	

   
	/*===================================================================================
			 Devuelve un listado de remitentes y los agrega a la caja de selección.
	 ===================================================================================*/

	
	$(document).on( 'click', '[data-sender]', function(e){
		
		e.preventDefault();
		

		if(arrayRemitentes == null || arrayRemitentes == undefined || arrayRemitentes == ''){

		$('.sltRemitente').empty();
		$('.sltRemitente').append('<option value="">...</option>');				
		$.ajax({
			url: baseDir + 'modules/sendingbay/ajax.php',
				type: 'POST',
				dataType: 'json',
				data : {
					action: 'factSenders',
					tipo: 'view'
				}, success: function( data ){
					
					
					
					// si la respuesta de la accion en db es verdadera
					if( data.remitentes ){

						arrayRemitentes = data.remitentes;

						$('.sltRemitente').empty();
						var i = 0;
						$.each(arrayRemitentes, function(key,value){


							var json = JSON.stringify(arrayRemitentes[i]);

							var data1 = json.replace(/ /g, "-");

							$('.sltRemitente').append('<option value='+data1+'>'+value.nombre+'</option>');
							//console.log('arrayRemitentes', json);
							i++;
						});

						//arrayRemitentes = null;


					}
					else{


					}
				}, error: function( d,x,v ) {
				
					console.log(d);
					console.log(x);
					console.log(v);
					
				}
		});

		

		}				
		
	});





	/**
	 * 
	 */
	 /*===================================================================================
	 * DEjecutamos el evento click en el select para mostrar la data de cada remitente
	===================================================================================*/
	$( ".sltRemitente" ).change(function(e) {
		//e.preventDefault();
		var datos = $(".sltRemitente").val();
		var parsero = JSON.parse(datos);
		//$('.btn-transmitir').attr('id-remitente', parsero.id);
		$('.sltRemitente').attr('value', parsero.id);
		$('.btn-transmitir').attr('remitente', parsero.id);
		$('#nombre').attr('remitente', parsero.id);
		//console.log('datos', parsero);
		$('#idRemi').val(parsero.id);
		var nombre = parsero.nombre.replace(/-/g, " ");
		$('#nombre').val(nombre);
		var direccion = parsero.direccion.replace(/-/g, " ");
		$('#direccion').val(direccion);
		var poblacion = parsero.poblacion.replace(/-/g, " ");
		$('#poblacion').val(poblacion);
		$('#codPostal').val(parsero.cod_postal);
		$('#telefono').val(parsero.telefono);
		$('#email').val(parsero.email);
		$('#contacto').val(parsero.contacto);

		if(arrayRemitentes == null){
		$('.servicio').empty();
		$('.servicio').append('<option value="'+parsero.servicio+'">'+parsero.servicio+'</option>');
		$('.sltRemitente').empty();
		$('.sltRemitente').append('<option value="'+parsero.id+'">'+parsero.nombre+'</option>');
		}				
		
		

		let estado = parsero.estado;
		$('#sltEstado').val(estado);
		if(estado == 1){			
			$('#sltEstado').attr('disabled', true);
			$('#sltEstado').attr('value', 1);
		}else{
			$('#sltEstado').attr('disabled', false);
			$('#sltEstado').attr('value', 0);
		}
				

	});

	$(document).on( 'change', '[data-sender]', function(e){
		//e.preventDefault();
		var datos = $(this).val();
		var parsero = JSON.parse(datos);

		$(this).attr('value', parsero.id);
		//$(this).append('<option value="'+parsero.id+'">'+parsero.nombre+'</option>');
		console.log('datos', parsero.id);
						

	});



	$("#btnGuardar").click(function(e){

		e.preventDefault();

		$('#btnGuardar').attr('disabled', true);
		let user = $('.txtUsuario').val();
		let pass = $('.txtClave').val();
		let ws = $('.urlWS').val();
		let iris = $('.urlIris').val();
		let dpto = $('.departamento').val();
		let carrier = $('.carrier').val();
		let documentado = $('.documentado').val();
		let reparto = $('.reparto').val();
		let entregado = $('.entregado').val();
		let cron = $('.cronHora').val();
		let grid = $('.chkGrid:checked').val();

		if(grid == "on"){
			grid = 'true';
		}else{
			grid = 'false';
		}

		/*console.log('user', user);
		console.log('pass', pass);
		console.log('ws', ws);
		console.log('iris', iris);
		console.log('dpto', dpto);
		console.log('carrier', carrier);
		console.log('documentador', documentado);
		console.log('reparto', reparto);
		console.log('entregado', entregado);*/

		if(user == '' || pass == '' || ws == '' ){
			alert('Todos los campos son obligatorios');
			$('#btnGuardar').attr('disabled', false);
		}else{

			user = user.replace(/ /g, "");
			pass = pass.replace(/ /g, "");
			
			$.ajax({
				url: baseDir + 'modules/sendingbay/ajax.php',
				type: 'POST',
				dataType: 'json',
				data: {
					action: 'saveConfig',
					user: user,
					pass: pass,
					ws: ws,
					iris: iris,
					dpto: dpto,
					carrier: carrier,
					documentado: documentado,
					reparto: reparto,
					entregado: entregado,
					cron: cron,
					grid: grid
				},
				success: function( data ){
					console.log('data', data);
					if(data){

						$('#btnGuardar').attr('disabled', false);

						Swal.fire({
							title   : 'Configuración',
							text    : 'Datos guardados correctamente',
							icon    : 'success',
							timer   : 3000
						});

						if(data.login == "true" ){ 

						   $('.loginT').html('<i class="icon-check" style="color:#8bc34a"></i>');
						   $('.loginS').html('<i class="icon-check" style="color:#8bc34a"></i>');

					   
						}else{

						   $('.loginT').html('X');

						   setTimeout(() => {

							   Swal.fire({
								   title   : 'Login User',
								   text    : 'Verifique que las credenciales de acceso sean correctas',
								   icon    : 'error',
								   timer   : 5000
							   });
							   
						   }, 2000);


						}

						
						//location.reload();
					}else{
						alert('Error al guardar los datos');
						$('#btnGuardar').attr('disabled', false);
					}
				}, error: function( d,x,v ) {
				
					console.log(d);
					console.log(x);
					console.log(v);
					$('#btnGuardar').attr('disabled', false);
					
				}
			});

		}
	});

   
   /**============================================================================================
	  * Ejecutamos el evento click en el select para traer servicios autorizados del cliente
	 ==============================================================================================*/
	
	$(document).on( 'click', '[data-service]', function(e){
		
		e.preventDefault();

		//var dir = $('.imgSpinner').attr('dir');
		//$('.imgLoading').attr('style', 'display:block; margin:3px 4px;')
		if(arrayServicios == null){

		//$('.servicio').empty();
		$('.servicio').append('<option value="">...</option>');				
		$.ajax({
				url: baseDir + 'modules/sendingbay/ajax.php',
				type: 'POST',
				dataType: 'json',
				data : {
					action: 'factService',
					tipo: 'view'
				}, success: function( data ){
															
					// si la respuesta de la accion en db es verdadera
					if( data.servicios ){

						let servicios = data.servicios;

						//split convierte una cadena string indentificada por un separador(" " , - etc) en un array
						arrayServicios = servicios.split(" ");

						//console.log('arrayServicios', arrayServicios);

						console.log('Query', data.query);
						$('.servicio').empty();

						$.each(arrayServicios, function(key,value){
							$('.servicio').append('<option value="'+value+'">'+value+'</option>');
						});

						//$('.imgLoading').attr('style', 'display:none;')

					}
					else{

						$('.servicio').empty();
						Swal.fire({
							title   : 'Datos',
							text    : 'Info: Verifique que las credenciales estan bien configuradas' ,
							icon    : 'error',
							timer   : 5000
						});
					}
				}, error: function( d,x,v ) {
				
					console.log(d);
					console.log(x);
					console.log(v);
					$('.servicio').empty();
					
				}
		});

		}				
		
	});


	/**========================================================================================================================================================
	  * Ejecutamos el evento click en el select para vincular el Estado Documentado con un estado de la orden para sincronizar con el actualizador de estados.
	 ==========================================================================================================================================================*/

	$( "#sltDocumentado" ).click(function(e) {

		if(arrayDocumentado == null){

			
			$.ajax({
					url: baseDir + 'modules/sendingbay/ajax.php',
					type: 'POST',
					dataType: 'json',
					data : {
						action: 'factStates',
						tipo: 'view'
					}, success: function( data ){
						
						// si la respuesta de la accion en db es verdadera
						if( data.estados ){
	
							var estados = data.estados;
	
							//split convierte una cadena string indentificada por un separador(" " , - etc) en un array
							arrayDocumentado = estados;
	
							console.log('estados', estados);
							
							$('#sltDocumentado').empty();
	
							$.each(arrayDocumentado, function(key,value){
								$('#sltDocumentado').append('<option value="'+value.id_order_state+'-'+value.name+'">'+value.name+'</option>');
							});
	
							$('#sltDocumentado').append('<option value="">Ninguno</option>');
	
	
						}
						else{
	
	
						}
					}, error: function( d,x,v ) {
					
						console.log(d);
						console.log(x);
						console.log(v);
						
					}
			});	
			}	

	});


	/**========================================================================================================================================================
	  * Ejecutamos el evento click en el select para vincular el Estado Reparto con un estado de la orden para sincronizar con el actualizador de estados.
	 ==========================================================================================================================================================*/

	$( "#sltReparto" ).click(function(e) {

		if(arrayReparto == null){

			
			$.ajax({
					url: baseDir + 'modules/sendingbay/ajax.php',
					type: 'POST',
					dataType: 'json',
					data : {
						action: 'factStates',
						tipo: 'view'
					}, success: function( data ){
						
						// si la respuesta de la accion en db es verdadera
						if( data.estados ){
	
							var estados = data.estados;
	
							//split convierte una cadena string indentificada por un separador(" " , - etc) en un array
							arrayReparto = estados;
	
							console.log('estados', estados);
							
							$('#sltReparto').empty();
	
							$.each(arrayReparto, function(key,value){
								$('#sltReparto').append('<option value="'+value.id_order_state+'-'+value.name+'">'+value.name+'</option>');
							});
	
							$('#sltReparto').append('<option value="">Ninguno</option>');
	
	
						}
						else{
	
	
						}
					}, error: function( d,x,v ) {
					
						console.log(d);
						console.log(x);
						console.log(v);
						
					}
			});	
			}	
	});


	/**========================================================================================================================================================
	  * Ejecutamos el evento click en el select para vincular el Estado Entregado con un estado de la orden para sincronizar con el actualizador de estados.
	 ==========================================================================================================================================================*/

	$( "#sltEntregado" ).click(function(e) {

		if(arrayEntregado == null){

			
			$.ajax({
					url: baseDir + 'modules/sendingbay/ajax.php',
					type: 'POST',
					dataType: 'json',
					data : {
						action: 'factStates',
						tipo: 'view'
					}, success: function( data ){
						
						// si la respuesta de la accion en db es verdadera
						if( data.estados ){
	
							var estados = data.estados;
	
							//split convierte una cadena string indentificada por un separador(" " , - etc) en un array
							arrayEntregado = estados;
	
							console.log('estados', estados);
							
							$('#sltEntregado').empty();
	
							$.each(arrayEntregado, function(key,value){
								$('#sltEntregado').append('<option value="'+value.id_order_state+'-'+value.name+'">'+value.name+'</option>');
							});
	
							$('#sltEntregado').append('<option value="">Ninguno</option>');
	
	
						}
						else{
	
	
						}
					}, error: function( d,x,v ) {
					
						console.log(d);
						console.log(x);
						console.log(v);
						
					}
			});	
			}	


	});

	/**
	 * Ejecutamos el evento click en el select para traer los estados de ordenes
	 
	
	$(document).on( 'click', '[data-estados]', function(e){
		
		e.preventDefault();

				
		
	});*/

	/**
	 * 
	 */
	/**============================================================================================
	  * Ejecutamos el evento click en el select para traer los transportistas habilitados
	==============================================================================================*/
	
	$(document).on( 'click', '[data-carrier]', function(e){
		
		e.preventDefault();
		var ids;

		

		if(arrayCarrier == null){

			
		$.ajax({
				url: baseDir + 'modules/sendingbay/ajax.php',
				type: 'POST',
				dataType: 'json',
				data : {
					action: 'factCarrier',
					tipo: 'view'
				}, success: function( data ){
					
					// si la respuesta de la accion en db es verdadera
					if( data.carrier ){

						var carrier = data.carrier;

						//split convierte una cadena string indentificada por un separador(" " , - etc) en un array
						arrayCarrier = carrier;

						console.log('carrier', carrier);

						if(carrier != null){

							ids = data.ids.toString().split(",");
							console.log('IDS', ids);

						}



						
						$('.select-carrier').empty();

						if(ids != ['false']){

						$.each(arrayCarrier, function(key,value){

							let valid = false;

							$.each(ids, function(key1,value1){

								if(value.id_carrier == value1){

									$('.select-carrier').append('<option selected value="'+value.id_carrier+'">'+value.name+'</option>');
									valid = true;
								}

							});

							if(valid == false)
								$('.select-carrier').append('<option value="'+value.id_carrier+'">'+value.name+'</option>');
									
						
						});

					   }

						$('.select-carrier').append('<option value="all">Ninguno</option>');


					}
					else{


					}
				}, error: function( d,x,v ) {
				
					console.log(d);
					console.log(x);
					console.log(v);
					
				}
		});	
	}					
		
	});


   

   /**
	 * 
	 */
	/**============================================================================================
	  * Ejecutamos el evento click en el boton de nuevo remitente para limpliar los controles
	==============================================================================================*/
	$('.newSender').on('click', function(e){ 

		//e.preventDefault();

		$('#idRemi').val('');
		$('#nombre').val('');
		$('#direccion').val('');
		$('#poblacion').val('');
		$('#codPostal').val('');
		$('#telefono').val('');
		$('#email').val('');
		$('#contacto').val('');
		$('#nombre').attr('remitente','');
		$('#sltEstado').attr('disabled', false);
		$('#sltRemitente').empty();
		$('#sltRemitente').append('<option value="">Nuevo Remitente</option>');

	})


		/**
	 *
	 */
	/**============================================================================================
	  *  Ejecutamos el evento click en el boton de guardar remitente fact
	==============================================================================================*/
	$('.remitentegs').on('click', function(e){

		e.preventDefault();

		$('.remitentegs').attr('disabled', true);

		//$('.remitentegs').addClass('disabled');
		$('.imgSpinner').removeClass('hide');

		var idRemitente = $('#idRemi').val();
		console.log('id', idRemitente.typeOf);

		if(idRemitente != ""){

			accion = 'update';

		}else{

			accion = 'add';
		}

		var $nombre = $('#nombre'),
		nb = $nombre.val();
		var direccion = $('#direccion').val();
		var $poblacion = $('#poblacion'),
		pb = $poblacion.val();
		var codPostal = $('#codPostal').val();
		var pais = $('#pais').val().toUpperCase();
		var $telefono = $('#telefono'),
		tf = $telefono.val();
		var email = $('#email').val();
		var contacto = $('#contacto').val();
		let observacion = $('#observaciones').val();
		let servicio = '1';
		if($(".chkServicio:checked").val() == "on"){

			$('.servicio1').val() != "" ? servicio = $('.servicio1').val() : servicio = '1';

		}else{

			$('#sltServicio').val() != "" ? servicio = $('#sltServicio').val() : servicio = '1';

		}
		let estado ;
 
		$('#sltEstado').val() != "" ? estado = $('#sltEstado').val() : estado = 0 ;
			
			//verificamos que ningunos de los campos del formulario estés vacios
			if(nb == ""){
				$('#nombre').addClass('invalid');
				$('.remitentegs').removeClass('disabled');
				$('.imgSpinner').addClass('hide');
				Swal.fire({title   : 'Grabe Remitente con los datos requeridos', icon : 'error'});
			}else if(pb == ""){
				$('#poblacion').addClass('invalid');
				$('.remitentegs').removeClass('disabled');
				$('.imgSpinner').addClass('hide');
				Swal.fire({title   : 'Grabe Remitente con los datos requeridos', icon : 'error'});
			}else if(tf == ""){
				$('#telefono').addClass('invalid');
				$('.remitentegs').removeClass('disabled');
				$('.imgSpinner').addClass('hide');
				Swal.fire({title   : 'Grabe Remitente con los datos requeridos', icon : 'error'});
				
			} else if(nb != "" && nb != "" && tf != ""){


				//ejecutamos ajax para el guardado de los datos en db
				$.ajax({
					url: baseDir + 'modules/sendingbay/ajax.php',
					type: 'POST',
					dataType: 'json',
					data : {
						action: 'newSender',
						remitente: idRemitente,
						nombre: nb,
						direccion: direccion,
						poblacion: pb,
						codigo: codPostal,
						pais: pais,
						telefono: tf,
						email: email,
						contacto: contacto,
						observaciones: observacion,
						servicio: servicio,
						estado: estado,
						tipo: accion
					}, success: function( data ){
						console.log('result', data);

						console.log('accion', accion);

						// si la respuesta de la accion en db es verdadera
						if( data.result ){
							//console.log('observa', data.observa);
							
							//$('#btnRemitente').removeClass('disabled');
							$('.imgSpinner').addClass('hide');

							$('.remitentegs').attr('disabled', false);

							setTimeout(function(){

								Swal.fire({
									title   : 'Remitente',
									text    : 'Datos guardados correctamente',
									icon    : 'success',
									timer   : 5000
								});

								//window.location.reload(); 

								//$('.remitentegs').removeClass('disabled');

							},1000);

						}
						else{
							$('.remitentegs').attr('disabled', false);
						}
					}, error: function( d,x,v ) {
					
						console.log(d);
						console.log(x);
						console.log(v);
						$('.remitentegs').attr('disabled', false);
						
					}
				});
	
			}
		
	})


		/**
	 * 
	 */
	/**============================================================================================
	  *  Ejecutamos la funcion de actualización de estados de los envíos
	==============================================================================================*/
	$('.update-state-send').on('click', function(e){
		e.preventDefault();
		$('.update-state-send').addClass('disabled');
		$.ajax({
			url: baseDir + 'modules/sendingbay/ajax.php',
			type: 'POST',
			dataType: 'json',
			data : {
				action: 'updateState',
				boton: true
			}, success: function( data ){
				if(data.result){

					$('#notifySend').attr('style','display: block; margin-top: -12px;');
					$('.update-state-send').removeClass('disabled');
					setTimeout(function(){

						$('#notifySend').fadeOut(1000);

					},2000);
				}
				
			console.log(data.result);
			console.log(data.final);

			}, error: function( d,x,v ) {
			
				console.log(d);
				console.log(x);
				console.log(v);
				
			}
		});

   })


   /**
	 * 
	 */
	/**============================================================================================
	  *  Ejecutamos la función de actualización de estados de las recogidas
	==============================================================================================*/
   $('.update-state-return').on('click', function(e){
		e.preventDefault();
		$('.update-state-return').addClass('disabled');
		$.ajax({
			url: baseDir + 'modules/sendingbay/ajax.php',
			type: 'POST',
			dataType: 'json',
			data : {
				action: 'updateStateD'
			}, success: function( data ){
				if(data.result){

					$('#notifyReturn').attr('style','display: block; margin-top: -12px;');
					$('.update-state-return').removeClass('disabled');
					setTimeout(function(){

						$('#notifyReturn').fadeOut(1000);

					},2000);
				}
				
			//console.log(data.result.length)

			}, error: function( d,x,v ) {
			
				console.log(d);
				console.log(x);
				console.log(v);
				
			}
		});

   })

   /**
	 * Ejecutamos la funcion de actualización de estados de las recogidas
	 
   $('.tranMasive').click( function(){
		
		console.log('Masiva');
					
		setTimeout(function(){

			window.location.reload(); 

		},2000);			

   })*/

   	/**========================================================================================
	* Ejecutamos el evento click en todos los checkbox  para agregar el enlace de transmision masiva
	============================================================================================*/

	$('#chkAll').change(function () {

		$('input[type=checkbox]').prop('checked', $(this).is(':checked'));

		chekarray = [];

		setTimeout(function () {

			$('.chkOrigen:checked').each(
				function () {
					chekarray.push($(this, ":checked").attr('check-id'));
					//arrayEnvio.push($(this,":checked ").attr('remitente'));							
				}
			);

			if (chekarray.length > 0) {

				$('#btnTranMasive').attr('style', 'display:block; text-align-last: end;');

			} else if (chekarray.length < 1) {

				$('#btnTranMasive').attr('style', 'display:none;');
			}

			console.log('dentro', chekarray);
			//console.log('dentro', arrayEnvio);


		}, 500);

	});

		/**========================================================================================
	* Ejecutamos el evento click en cada checkbox  para agregar el enlace de transmision masiva
	===========================================================================================*/

	$(document).on('click', '[check-id]', function () {


		chekarray = [];

		$('label input:checked').each(
			function () {
				//checkArray2 = $(this,":checked ").attr('envio') + $(this,":checked ").attr('envio');
				chekarray.push($(this, ":checked ").attr('check-id'));
				//arrayEnvio.push($(this,":checked ").attr('remitente'));	

			}
		);

		if (chekarray[0] == null) {

			chekarray.shift();

		}

		if (chekarray.length > 0) {

			$('#btnTranMasive').attr('style', 'display:block; text-align-last: end;');

		} else if (chekarray.length < 1) {

			$('#btnTranMasive').attr('style', 'display:none;');
		}


		console.log('dentro', chekarray);


	});

   	 /**
	  * 
	  */
	 /**========================================================================================================
	  *  Ejecutamos el evento click en el boton de filtrar ordenes transmitidas al Fact en un rango de Fechas
	==============================================================================================================*/
	$('#btnFiltrarP').on('click', function(e){ 
 
		//e.preventDefault();

		$('#btnFiltrarP').addClass('disabled');

		let desde = $('#fechaDesdeP').val();
		let hasta = $('#fechaHastaP').val();

		$('#areaPedidos').attr('style','display: block;');
		$('#tblPedidos').html('<tr><td colspan="7" style="text-align:center;"><img src="'+baseDir+'modules/sendingbay/views/img/loader2.gif" width="60px"/></td></tr>');
		$('.mensaje').html('');
		$('#btnPrintMasive').attr('style','display:none;');

		
		$.ajax({

			url: baseDir + 'modules/sendingbay/ajax.php',
			type: 'POST',
			dataType: 'json',
			data: {
				action: 'filterOrdersP',
				desde : desde,
				hasta: hasta,
			}, success: function( data ) {

				if( data.info){

					
					$('#tblPedidos').html('');

					var datos = data.info;
					//console.log(data.request);
					let carriers = data.carriers;
					let anterior = '';
					let actual = '';

					if(datos.length > 0){

						var element;
	

					   var i;
					   for (i in datos) {
						   element = datos[i];
						   //console.log(veri.devuelto);

						   actual = element.id_order;

						   if(actual != anterior){

							if( carriers == 'all' ){

							   
							   document.getElementById("tblPedidos").innerHTML += '<tr id="idR" idRegistro="">'+
							   "<td id='sel-" + element.id_order + "'><div  ><label><input type='checkbox' class='chkOrigen' name='orderBox[]' check-id='" +element.id_order + "'  ><span class='lever'></span></label></div></td>" +
							   '<td id="fechaP" fecha="">'+ element.fecha +'</td>'+
							   '<td id="refeP" refeP="'+ element.reference +'">'+ element.reference +'</td>'+
							   '<td id="ordenP" ordenP="'+ element.id_order +'">'+ element.id_order +'</td>'+
							   '<td id="clienteP" clienteP="'+ element.id_customer +'">'+ element.client +'</td>'+
							   '<td id="precioP" >'+ element.total +'</td>'+
							   '<td id="estadoP" estadoP="">'+ element.pago +'</td>'+
							   '<td id="print-'+element.id_order+'"><a btn-transmitir="" class="btn btn-default btn-secondary btnTransmitir" remitente="'+data.idRemi+'" nombre="'+data.nameR+'" servicio="'+data.servicio+'" data-order-id="'+ element.id_order +'" metodo-pago="'+element.pago+'" peso="1"><span>&nbsp;<i class="icon-send"></i>&nbsp;</span></a></td>'+ 
							   '</tr>';

							   anterior = element.id_order;

							}else{

								if(!carriers.includes(',')){

									console.log(carriers+' ??== '+element.id_carrier);

									if( carriers === element.id_carrier ){

										document.getElementById("tblPedidos").innerHTML += '<tr id="idR" idRegistro="">'+
										"<td id='sel-" + element.id_order + "'><div  ><label><input type='checkbox' class='chkOrigen' name='orderBox[]' check-id='" +element.id_order + "'  ><span class='lever'></span></label></div></td>" +
										'<td id="fechaP" fecha="">'+ element.fecha +'</td>'+
										'<td id="refeP" refeP="'+ element.reference +'">'+ element.reference +'</td>'+
										'<td id="ordenP" ordenP="'+ element.id_order +'">'+ element.id_order +'</td>'+
										'<td id="clienteP" clienteP="'+ element.id_customer +'">'+ element.client +'</td>'+
										'<td id="precioP" >'+ element.total +'</td>'+
										'<td id="estadoP" estadoP="">'+ element.pago +'</td>'+
										'<td id="print-'+element.id_order+'"><a btn-transmitir="" class="btn btn-default btn-secondary btnTransmitir" remitente="'+data.idRemi+'" nombre="'+data.nameR+'" servicio="'+data.servicio+'" data-order-id="'+ element.id_order +'" metodo-pago="'+element.pago+'" peso="1"><span>&nbsp;<i class="icon-send"></i>&nbsp;</span></a></td>'+ 
										'</tr>';

										
									}
									anterior = element.id_order;
									

								}else{

									let carrier = carriers.split(',');

									console.log('ArrayCarrier', carriers);

									for (let index = 0; index < carrier.length; index++) {

										if( carrier[index] == element.id_carrier ){

											document.getElementById("tblPedidos").innerHTML += '<tr id="idR" idRegistro="">'+
											"<td id='sel-" + element.id_order + "'><div  ><label><input type='checkbox' class='chkOrigen' name='orderBox[]' check-id='" +element.id_order + "'  ><span class='lever'></span></label></div></td>" +
											'<td id="fechaP" fecha="">'+ element.fecha +'</td>'+
											'<td id="refeP" refeP="'+ element.reference +'">'+ element.reference +'</td>'+
											'<td id="ordenP" ordenP="'+ element.id_order +'">'+ element.id_order +'</td>'+
											'<td id="clienteP" clienteP="'+ element.id_customer +'">'+ element.client +'</td>'+
											'<td id="precioP" >'+ element.total +'</td>'+
											'<td id="estadoP" estadoP="">'+ element.pago +'</td>'+
											'<td id="print-'+element.id_order+'"><a btn-transmitir="" class="btn btn-default btn-secondary btnTransmitir" remitente="'+data.idRemi+'" nombre="'+data.nameR+'" servicio="'+data.servicio+'" data-order-id="'+ element.id_order +'" metodo-pago="'+element.pago+'" peso="1"><span>&nbsp;<i class="icon-send"></i>&nbsp;</span></a></td>'+ 
											'</tr>';
		
											
										}

										anterior = element.id_order;

									}
								  }
								}							
						   }
						}
					   }
					   
						
						
					}else{

						$('.mensaje').html('<tr class="text-center"><td colspan="8"><h2 style="padding: 30px;">Sin Registros</h2></td></tr>');
						$('#tblPedidos').html('');
						//console.log(data.request);

					}
					
					console.log(data.info);
					

					$('#btnFiltrarP').removeClass('disabled');
					

				
			}, error: function( d,x,v ) {
			
				console.log(d);
				console.log(x);
				console.log(v);
				$('#btnFiltrarP').removeClass('disabled');
				$('#tblPedidos').html('');
			

			}
		});
		

	});

 
   

 

 
	 /**
	  * 
	  */
	 /**========================================================================================================
	  *  Ejecutamos el evento click en el boton de filtrar ordenes transmitidas al Fact en un rango de Fechas
	==============================================================================================================*/
		 $('#btnFiltrar').on('click', function(e){ 
 
			 //e.preventDefault();
 
			 $('#btnFiltrar').addClass('disabled');
 
			 let desde = $('#fechaDesde').val();
			 let hasta = $('#fechaHasta').val();

			 
			 $.ajax({
 
				 url: baseDir + 'modules/sendingbay/ajax.php',
				 type: 'POST',
				 dataType: 'json',
				 data: {
					 action: 'filterOrders',
					 desde : desde,
					 hasta: hasta,
				 }, success: function( data ) {
 
					 if( data.info){
 

						 var datos = data.info;
						 var datos1 = data.info;
						 document.getElementById("tblOrdenes").innerHTML = '';
						 $('.mensaje').html('');
						 if(datos.length > 0){
							 $('#manifestSearch').css('display','block');

							 
 
							 datos1.forEach(llave => $('#fechaMasive').attr('alba-desde-masive', llave.albaran));
							 datos1.forEach(llave => $('#fechaMasive').attr('alba-hasta-masive', parseInt(llave.albaran) + (datos.length -1)));
							 var element;

							var i;
							for (i in datos) {
								element = datos[i];
								//console.log(veri.devuelto);

								if(element.devuelto == "0" && element.estado == "ENTREGADO"){


									document.getElementById("tblOrdenes").innerHTML += '<tr id="idR" idRegistro="">'+
									'<td id="fec" fecha="">'+ element.fecha +'</td><td id="ord" orden="'+ element.id_orden +'">'+ element.id_orden +'</td>'+
									'<td id="rec">'+ element.albaran +'</td><td id="cli" cliente ="">'+ element.cliente +'</td>'+
									'<td id="est" estado ="'+ element.estado +'">'+ element.estado +'</td><td id="seg" seguimiento =""><i class="icon-link"></i>&nbsp<a href ="'+ data.iris +''+ element.seguimiento +'" target="_blank" >'+ element.seguimiento +'</td>'+
									'<td><span data-fact-id-view="'+ element.albaran +'" class="btn btn-default"><a href="#" title=""><i class="icon-eye"></i></a></span></td>'+
									'<td><span data-fact-id-list="'+ element.albaran +'" class="btn btn-default"><a href="#" title=""><i class="icon-list"></i></a></span></td>'+
									'<td><span data-fact-id-label="'+ element.albaran +'"  class="btn btn-default labelfact"><a href="#" title=""><i class="icon-print"></i></a></span></td>'+
									'<td><span data-fact-id-devolucion="'+ element.albaran +'" class="btn btn-default" ><a href="#" title="Devolución"><i class="icon-repeat"></i></a></span></td>'+ 
									'<td><span data-fact-id-cambio="'+ element.albaran +'" class="btn btn-default btnChange" ><a href="#" title="Cambio"><i class="icon-repeat"></i></a></span></td>'+ 
									'</tr>';
								}else{
	
									document.getElementById("tblOrdenes").innerHTML += '<tr id="idR" idRegistro="">'+
									'<td id="fec" fecha="">'+ element.fecha +'</td><td id="ord" orden="'+ element.id_orden +'">'+ element.id_orden +'</td>'+
									'<td id="rec">'+ element.albaran +'</td><td id="cli" cliente ="">'+ element.cliente +'</td>'+
									'<td id="est" estado ="'+ element.estado +'">'+ element.estado +'</td><td id="seg" seguimiento =""><i class="icon-link"></i>&nbsp<a href ="'+ data.iris +''+ element.seguimiento +'" target="_blank" >'+ element.seguimiento +'</td>'+
									'<td><span data-fact-id-view="'+ element.albaran +'" class="btn btn-default"><a href="#" title=""><i class="icon-eye"></i></a></span></td>'+
									'<td><span data-fact-id-list="'+ element.albaran +'" class="btn btn-default"><a href="#" title=""><i class="icon-list"></i></a></span></td>'+
									'<td><span data-fact-id-label="'+ element.albaran +'"  class="btn btn-default labelfact"><a href="#" title=""><i class="icon-print"></i></a></span></td>'+
									'<td><span data-fact-id-devolucion="'+ element.albaran +'" class="btn btn-default disabled" ><a href="#" title="Devolución"><i class="icon-repeat"></i></a></span></td>'+ 
									'<td><span data-fact-id-cambio="'+ element.albaran +'" class="btn btn-default disabled" ><a href="#" title="Cambio"><i class="icon-repeat"></i></a></span></td>'+
									'</tr>';
								}
							}
							
							 
							 
						 }else{
 
							 $('.mensaje').html('<tr class="text-center"><td colspan="8"><h2 style="padding: 30px;">Sin Registros</h2></td></tr>');
 
						 }
						 
 
 
						 $('#btnFiltrar').removeClass('disabled');
						 
 
					 }
					 else{
						 Swal.fire({
							 title   : 'Etiqueta',
							 text    : 'Info: ' + data.mensaje + '',
							 type    : 'error',
							 timer   : 3500
						 });
						 $('#btnFiltrar').removeClass('disabled');
 
					 }
				 }, error: function( d,x,v ) {
				 
					 console.log(d);
					 console.log(x);
					 console.log(v);
					 $('#btnFiltrar').removeClass('disabled');
				 
 
				 }
			 });
			 
 
		 });


		/**
	  *
	  */
	 /**========================================================================================================
	  *   Ejecutamos el evento click en el boton de filtrar ordenes transmitidas al Fact en un rango de Fechas
	==============================================================================================================*/
	 $('#btnFiltrarD').on('click', function(e){ 
 
		//e.preventDefault();

		$('#btnFiltrarD').addClass('disabled');

		let desde = $('#fechaDesdeD').val();
		let hasta = $('#fechaHastaD').val();
		
		$.ajax({

			url: baseDir + 'modules/sendingbay/ajax.php',
			type: 'POST',
			dataType: 'json',
			data: {
				action: 'filterReturns',
				desde : desde,
				hasta: hasta,
			}, success: function( data ) {

				if( data.info){



					var datos = data.info;
					var datos1 = data.info;
					document.getElementById("tblOrdenesD").innerHTML = '';
					$('.mensajeD').html('');
					if(datos.length > 0){
						$('#manifestSearchD').css('display','block');

						datos.forEach(element => document.getElementById("tblOrdenesD").innerHTML += '<tr id="idR" idRegistro="">'+
							'<td id="fecD" fecha="">'+ element.fecha +'</td><td id="ord" orden="'+ element.id_orden +'">'+ element.id_orden +'</td>'+
							'<td id="recD" recogida ="">'+ element.recogida +'</td><td id="cliD" cliente ="">'+ element.cliente +'</td>'+
							'<td id="estD" estado ="'+ element.estado +'">'+ element.estado +'</td><td id="segD" seguimiento =""><i class="material-icons">link</i><a href ="'+ data.iris +''+ element.seguimiento +'" target="_blank" >'+ element.seguimiento +'</td>'+
							'<td><span data-fact-return-view="'+ element.recogida +'" class="btn btn-default"><a href="#" title=""><i class="icon-eye"></i></a></span></td>'+
							'<td><span data-fact-return-list="'+ element.recogida +'" class="btn btn-default"><a href="#" title=""><i class="icon-list"></i></a></span></td>'+
							'<td><span data-fact-return-label="'+ element.recogida +'"  class="btn btn-default labelfactD"><a href="#" title=""><i class="icon-print"></i></a></span></td>'+
							'</tr>'); 
					   
						
						
					}else{

						$('.mensajeD').html('<tr class="text-center"><td colspan="8"><h2 style="padding: 30px;">Sin Registros</h2></td></tr>');

					}
					


					$('#btnFiltrarD').removeClass('disabled');
					

				}
				else{
					Swal.fire({
						title   : 'Etiqueta',
						text    : 'Info: ' + data.mensaje + '',
						type    : 'error',
						timer   : 3500
					});
					$('#btnFiltrarD').removeClass('disabled');

				}
			}, error: function( d,x,v ) {
			
				console.log(d);
				console.log(x);
				console.log(v);
				
				$('#btnFiltrarD').removeClass('disabled');

			}
		});
		

	});


 
	  /**
	  * 
	  */
	  /**========================================================================================================
	  *   Ejecutamos el evento click en el boton ver detalles del envío fact
	==============================================================================================================*/
	 $(document).on( 'click', '[data-fact-id-view]', function(e){
		e.preventDefault();
 
		 $('#tblEnvio tbody tr td').html( '' );
		 $('.spinner-border').css('display','block');
 
		 var albaran = $(this).attr('data-fact-id-view');
		 //console.log('albaran', albaran);
		 
		 $('#view_fact_order').modal();
 
		 if(albaran != null){
			 //$preload.css('display','flex');
			 $.ajax({
				 url: baseDir + 'modules/sendingbay/ajax.php',
				 type: 'POST',
				 dataType: 'json',
				 data : {
					 action: 'viewOrder',
					 albaran: albaran,
					 tipo: 'view'
				 }, success: function( data ){

				   //console.log('result', JSON.stringify(data.llaves));
										 
					 // si la respuesta de la accion en db es verdadera
					 if( data.llaves ){
					   
						let envio = JSON.stringify(data.llaves)
						 $('.spinner-border').css('display','none');
						 console.log('llaves', envio);
						 $('#tblEnvio tbody tr td').append( envio.replace(/{"/g, '').replace(/","/g, '').replace(/":"/g, ': ').replace(/"}/g, '') );
						 
						 //esperamos un segundo y redirigimos a la pagina fact_options
						 setTimeout(function(){
							 //$preload.css('display','none');
						 },300);
 
					 }
					 else{
 
					 }
				 }, error: function( d,x,v ) {
				 
					 console.log(d);
					 console.log(x);
					 console.log(v);
					 
				 }
			 });
		 }
 
	 });

	 /**
	  * 
	  */
	  /**========================================================================================================
	  *  Ejecutamos el evento click en el boton ver detalles de la recogida fact
	==============================================================================================================*/
	 
	 $(document).on( 'click', '[data-fact-return-view]', function(){
 
		$('#tblRecogida tbody tr td').html( '' );
		$('.spinner-border').css('display','block');

		var recogida = $(this).attr('data-fact-return-view');
		//console.log('albaran', albaran);
		
		$('#view_return_order').modal();

		if(recogida != null){
			//$preload.css('display','flex');
			$.ajax({
				url: baseDir + 'modules/sendingbay/ajax.php',
				type: 'POST',
				dataType: 'json',
				data : {
					action: 'viewReturn',
					recogida: recogida,
					tipo: 'view'
				}, success: function( data ){
										
					// si la respuesta de la accion en db es verdadera
					if( data.llaves ){

						$('.spinner-border').css('display','none');
						//console.log('llaves', data.llaves);
						$('#tblRecogida tbody tr td').append( data.llaves );						

					}
					else{

					}
				}, error: function( d,x,v ) {
				
					console.log(d);
					console.log(x);
					console.log(v);
					
				}
			});
		}
	});

 
	 /**
	  * 
	  */ 
	  /**========================================================================================================
	  * Ejecutamos el evento click para visualizar los estados del Añbaran
	==============================================================================================================*/
	 $(document).on( 'click', '[data-fact-id-list]', function(e){

		e.preventDefault();
 
		 $('#tblEstados tbody').html( '' );
 
		 var albaran = $(this).attr('data-fact-id-list');
		 
		 $('#view_fact_list').modal();
 
		 if(albaran != null){
			 $('.spinner-border').css('display','block');
			 $.ajax({
				 url: baseDir + 'modules/sendingbay/ajax.php',
				 type: 'POST',
				 dataType: 'json',
				 data : {
					 action: 'viewState',
					 albaran: albaran,
					 tipo: 'view'
				 }, success: function( data ){				
					 
					 // si la respuesta de la accion en db es verdadera
					 if( data.estados ){
 
						 $('.spinner-border').css('display','none');
 
						 $('#tblEstados tbody').append( data.estados);
						 
						 //esperamos un segundo y redirigimos a la pagina fact_options
						 setTimeout(function(){
							 
						 },300);
 
					 }
					 else{
 
 
					 }
				 }, error: function( d,x,v ) {
				 
					 console.log(d);
					 console.log(x);
					 console.log(v);
					 
				 }
			 });
		 }
 
	 });

	 /**
	  * 
	  */ 
	 /**========================================================================================================
	  * Ejecutamos el evento click en el boton de ver estados de la recogida fact
	==============================================================================================================*/
	 $(document).on( 'click', '[data-fact-return-list]', function(){
 
		$('#tblEstadosD tbody').html( '' );

		var recogida = $(this).attr('data-fact-return-list');
		
		$('#view_return_list').modal();

		if(recogida != null){
			$('.spinner-border').css('display','block');
			$.ajax({
				url: baseDir + 'modules/sendingbay/ajax.php',
				type: 'POST',
				dataType: 'json',
				data : {
					action: 'viewStateD',
					recogida: recogida,
					tipo: 'view'
				}, success: function( data ){				
					
					// si la respuesta de la accion en db es verdadera
					if( data.estados ){

						$('.spinner-border').css('display','none');

						$('#tblEstadosD tbody').append( data.estados);

					}
					else{


					}
				}, error: function( d,x,v ) {
				
					console.log(d);
					console.log(x);
					console.log(v);
					
				}
			});
		}

	});
 
	 /**
	  * 
	  */
	 /**=====================================================================================================================
	  * Ejecutamos el evento click en el boton para imprimir la etiqueta del envío desde el listado de ordenes transmitidas
	========================================================================================================================*/
	 $(document).on( 'click', '[data-fact-id-label]', function(e){
		 
		 e.preventDefault();
		 $('#urlLabelPdf').attr('href','');
		 $('#ifmLabelPdf').attr('src','');
		 $(this).addClass('disabled');
 
		 var albaran = $(this).attr('data-fact-id-label');
		 //console.log('albaran', albaran);
		 
		 //$('#view_fact_label').modal('open');
 
		 if(albaran != null){
			 //$('.spinner-border').css('display','flex');
 
			 $.ajax({
				 url: baseDir + 'modules/sendingbay/ajax.php',
				 type: 'POST',
				 dataType: 'json',
				 data : {
					 action: 'labelPrint',
					 albaran: albaran,
					 tipo: 'view'
				 }, success: function( data ){
					 
					 
					 // si la respuesta de la accion en db es verdadera
					 if( data.etiqueta){
						 
						 //$('#tblEtiqueta tbody tr td').append( data.etiqueta );
						 $('#urlLabelPdf').attr('href',data.etiqueta);
						 $('#ifmLabelPdf').attr('src',data.etiqueta);
						 
						 window.open(data.etiqueta);
						 
 
						 setTimeout(function(){
							 
							$('.labelfact').removeClass('disabled'); 
						 },3000);
 
					 }
					 else{
						 //$('#view_fact_label').modal('close');
 
						 Swal.fire({
							 title   : 'Etiqueta',
							 text    : 'Info: ' + data.mensaje + '',
							 type    : 'error',
							 timer   : 3500
						 });
						 $('.labelfact').removeClass('disabled'); 
 
					 }
				 }, error: function( d,x,v ) {
				 
					 console.log(d);
					 console.log(x);
					 console.log(v);
					 $('.labelfact').removeClass('disabled'); 
					 
				 }
			 });
			 
		 }
 
	 });

	 /**
	  * 
	  */
	  /**=========================================================================================================================
	  * Ejecutamos el evento click en el boton para imprimir la etiqueta de la recogida desde el listado de ordenes transmitidas
	=============================================================================================================================*/
	 $(document).on( 'click', '[data-fact-return-label]', function(e){
		e.preventDefault();

		$(this).addClass('disabled');

		var recogida = $(this).attr('data-fact-return-label');
		//console.log('albaran', albaran);
		
		//$('#view_fact_label').modal('open');

		if(recogida != null){

			$.ajax({
				url: baseDir + 'modules/sendingbay/ajax.php',
				type: 'POST',
				dataType: 'json',
				data : {
					action: 'labelPrintD',
					recogida: recogida,
					tipo: 'view'
				}, success: function( data ){
										
					// si la respuesta de la accion en db es verdadera
					if( data.etiqueta){
						
						
						window.open(data.etiqueta);
						setTimeout(function(){
							 
							$('.labelfactD').removeClass('disabled'); 
						 },3000);
						

					}
					else{

						Swal.fire({
							title   : 'Etiqueta',
							text    : 'Info: ' + data.mensaje + '',
							type    : 'error',
							timer   : 3500
						});
						$('.labelfactD').removeClass('disabled'); 

					}
				}, error: function( d,x,v ) {
				
					console.log(d);
					console.log(x);
					console.log(v);
					$('.labelfactD').removeClass('disabled'); 
				}
			});
			
		}

	});

 
	 /**
	  * 
	  */
	 /**=========================================================================================================================
	  * Ejecutamos el evento click en el boton para mostrar e imprimir las etiquetas PDF en Masivo
	=============================================================================================================================*/
	 $(document).on( 'click', '[alba-desde-masive]', function(){
		 
		 $(this).addClass('disabled');
 
		 var albaranDesde = $(this).attr('alba-desde-masive');
		 var albaranHasta = $(this).attr('alba-hasta-masive');
		 
 
			 $.ajax({
				 url: baseDir + 'modules/sendingbay/ajax.php',
				 type: 'POST',
				 dataType: 'json',
				 data : {
					 action: 'printMasive',
					 albaDesde: albaranDesde,
					 albaHasta: albaranHasta,
					 tipo: 'view'
				 }, success: function( data ){					
					 
					 // si la respuesta de la accion en db es verdadera
					 if( data.etiqueta){
						 
						 window.open(data.etiqueta);
						 
						 setTimeout(function(){
							 $('.masive').removeClass('disabled');
							 //$preload.css('display','none');
						 },300);
 
					 }
					 else{
						 $('.masive').removeClass('disabled');
						 //$('#view_fact_masive').modal('close');
 
						 Swal.fire({
							 title   : 'Etiqueta',
							 text    : 'Info: ' + data.error + '',
							 type    : 'error',
							 timer   : 3500
						 });
 
					 }
				 }, error: function( d,x,v ) {
				 
					 console.log(d);
					 console.log(x);
					 console.log(v);
					 
				 }
			 }); 
	 
 
	 });
 
	 /**
	  * 
	  */
	 /**=========================================================================================================================
	  * Ejecutamos el evento click en el boton para mostrar el MANIFIESTO
	=============================================================================================================================*/
	 $(document).on( 'click', '[data-fact-id-manifest]', function(){
		 
 
		 $(this).addClass('disabled');
 
		 var albaran = $(this).attr('data-fact-id-manifest');
		 var fecha =  $('#fechaHasta').val();
		 //console.log('albaran', albaran);
		 
		 //$('#view_fact_manifest').modal('open');
 
		 if(fecha != null){
			 //$preload.css('display','flex');
 
			 $.ajax({
				 url: baseDir + 'modules/sendingbay/ajax.php',
				 type: 'POST',
				 dataType: 'json',
				 data : {
					 action: 'factManifest',
					 fecha: fecha,
					 tipo: 'view'
				 }, success: function( data ){
					// console.log('data', data);
					 
					 
					 // si la respuesta de la accion en db es verdadera
					 if( data.etiqueta){
						 
						 window.open(data.etiqueta);
						 
 
						 setTimeout(function(){
							 $('.manifest').removeClass('disabled');
							 //$preload.css('display','none');
						 },1000);
 
					 }
					 else{
						 $('.manifest').removeClass('disabled');
						 //$('#view_fact_manifest').modal('close');
 
						 Swal.fire({
							 title   : 'Etiqueta',
							 text    : 'Info: ' + data.mensaje + '',
							 type    : 'error',
							 timer   : 3500
						 });
 
					 }
				 }, error: function( d,x,v ) {
				 
					 console.log(d);
					 console.log(x);
					 console.log(v);
					 
				 }
			 }); 
		 }
 
	 });




	 /**
	 * 
	 */

	 /**=========================================================================================================================
	  * Ejecutamos el evento click en el checkbox de devolución para mostrar el formulario de una nueva dirección
	=============================================================================================================================*/
	
	 $(document).on('click', '[id-origen]', function() {
		//e.preventDefault();
		//console.log('funciona', $(".chkOrigen:checked").val());

		if($(".chkOrigen:checked").val() == "on"){
			
			$('#frmDesti').attr('style','display: block;');
		}else{
			$('#frmDesti').attr('style','display: none;');
		}

	});

	/**
	 * 
	 */
	 /**=========================================================================================================================
	  *Ejecutamos el evento click en el checkbox de devolución para mostrar el formulario de una nueva dirección
	=============================================================================================================================*/
	$(document).on('click', '[chk-servicio]', function() {
		//e.preventDefault();
		//console.log('funciona', $(".chkOrigen:checked").val());

		if($(".chkServicio:checked").val() == "on"){
			
			$('.servicio1').attr('style','display: block;');
			$('.servicio').attr('style','display: none;');
		}else{
			$('.servicio').attr('style','display: block;');
			$('.servicio1').attr('style','display: none;');
		}

	});

	 /**
	 * 
	 */
	/**=========================================================================================================================
	  *Ejecutamos el evento click en el boton de generar devolución/recogida
	=============================================================================================================================*/
	$(document).on( 'click', '[data-fact-id-devolucion]', function(e){
		e.preventDefault();

		var albaran = $(this).attr('data-fact-id-devolucion');
		$(this).addClass('disabled');
		//console.log('albaran', albaran);

		var html = 'Desea generar una recogida del envío con albaran: '+ albaran +'<br><div class="switch"><label style="font-size: small;"><input type="checkbox" id-origen="chkOrigen" class="chkOrigen form-control"><span class="lever"></span>'+
		'&nbsp;Indique otra dirección diferente a la de origen</label></div><div id="frmDesti" style="display:none;"><br><form action="" method="post" form-fact><table style="padding:5px;">'+
		'<tr><td><label for="nombre" style="font-size: 1rem; color: #9e9e9e;" class="active">Nombre</label><input type="text" id="nombre" value="" class="validate form-control" style="margin: 0px 1px;"></td>'+
		'<td><label for="direccion" style="font-size: 1rem; color: #9e9e9e;" class="active">Dirección</label><input type="text" id="direccion" value="" class="validate form-control" style="margin: 0px 1px;"></td></tr>'+
		'<tr><td><label for="poblacion" style="font-size: 1rem; color: #9e9e9e;" class="active">Población</label><input type="text" id="poblacion" value="" class="validate form-control" style="margin: 0px 1px;"></td>'+
		'<td><label for="codPostal" style="font-size: 1rem; color: #9e9e9e;" class="active">Codigo Postal</label><input type="text" id="codPostal" value="" class="validate form-control" style="margin: 0px 1px;"></td></tr>'+
		'<tr><td><label for="pais" style="font-size: 1rem; color: #9e9e9e;" class="active">Pais</label><input type="text" id="pais" value="ESP" class="validate form-control" style="margin: 0px 1px;"></td>'+
		'<td><label for="telefono" style="font-size: 1rem; color: #9e9e9e;" class="active">Teléfono</label><input type="text" id="telefono" value="" class="validate form-control" style="margin: 0px 1px;"></td></tr>'+
		'</table></form></div>';
		

		if(albaran != ""){

			Swal.fire({
				title				: "Devolver Pedido",
				//text				: 'Desea generar una recogida del envío con albaran: '+ albaran,
				html                : html,
				icon                : "question",
				showCancelButton    : true,
				confirmButtonText   : "SI",
				closeOnConfirm      : true,
				showLoaderOnConfirm : true,
				preConfirm: () => {
					return fetch('')
					  .then(response => {

						var origen = "";
						var nombre = "";
						var direccion = "";
						var poblacion = "";
						var postal = "";
						var pais = "";
						var telefono = "";


						//$("#chkOrigen:checked").val() == "Establecer otra dirección" ? origen = "true" : origen = "false";

						//verificamos que ningunos de los campos del formulario estés vacios
					if($(".chkOrigen:checked").val() == "on"){
						origen = $(".chkOrigen:checked").val();
						nombre = $("#nombre").val();
						direccion = $("#direccion").val();
						poblacion = $("#poblacion").val();
						postal = $("#codPostal").val();
						pais = $("#pais").val();
						telefono = $("#telefono").val();

					}
	
					$.ajax({

						url: baseDir + 'modules/sendingbay/ajax.php',
						type: 'POST',
						dataType: 'json',
						data: {
		
							action: 'factReturn',
							albaran: albaran,
							origen: origen,
							nombre: nombre,
							direccion: direccion,
							poblacion: poblacion,
							postal: postal,
							pais: pais,
							telefono: telefono


						}, success: function( data ){
							//console.log('data', data);				

								if(data.infoWs == 'OK'){

									//console.log('result', data.result);
									Swal.fire({
										title   : 'Transmisión al Fact',
										text    : 'Se ha generado correctamente una devolución con el numero de Recogida: '+ data.recogida +'',
										icon    : 'success',
										timer   : 5000
									});
									
									//location.href = url3;
									

									setTimeout(() => {

										window.location.reload();
										
									}, 3000);

								

								}else{
									

									Swal.fire({
										icon: 'error',
										title: 'Oops...',
										text: data.infoWs
									  })
									  
									  $(this).removeClass('disabled');
									$('.imgSpinner').addClass('hide');


								}

						}, error: function( d,x,v ) {
							
					
							console.log(d);
							console.log(x);
							console.log(v);
							
						}
					});
						
					  })
					  
				  },
				  allowOutsideClick: () => !Swal.isLoading()
			}).then((result) =>{
	
				if( result.isConfirmed ) {

		
						$(this).removeClass('disabled');
						

					
					
	
				} else {
		
						$(this).removeClass('disabled');
						$('.imgSpinner').addClass('hide');
	
					
	
				}
	
			}); 

			
		
	}
	
	});
 
 });


 /**
	 * Ejecutamos el evento click en el boton  de devolución para generar uma recogida de este albaran en el fact
	 */
 $(document).on( 'click', '[data-fact-id-cambio]', function(e){
	e.preventDefault();

	var albaran = $(this).attr('data-fact-id-cambio');
	$(this).addClass('disabled');
	//console.log('albaran', albaran);

	

	var html = 'Desea generar un cambio del envío '+ albaran +' donde el destinatario recibe la nueva mercancía y debe entregar una mercancía que será devuelta al remitente original<br>';
	

	if(albaran != ""){

		Swal.fire({
			title				: "Gestionar Cambio",
			//text				: 'Desea generar una recogida del envío con albaran: '+ albaran,
			html                : html,
			icon                : "question",
			showCancelButton    : true,
			confirmButtonText   : "SI",
			closeOnConfirm      : true,
			showLoaderOnConfirm : true,
			preConfirm: () => {
				return fetch('')
				  .then(response => {


				$.ajax({

					url: baseDir + 'modules/sendingbay/ajax.php',
					type: 'POST',
					dataType: 'json',
					data: {
	
						action: 'factChange',
						albaran: albaran,
						origen: 'no'
						

					}, success: function( data ){
						//console.log('data', data);				

							if(data.infoWs == 'OK'){

								//console.log('result', data.result);
								Swal.fire({
									title   : 'Transmisión al Fact',
									text    : 'Se ha generado correctamente un Cambio del envío '+ albaran +' con el numero de Albaran: '+ data.albaran +'',
									icon    : 'success',
									timer   : 5000
								});
								
								//location.href = url3;
								setTimeout(() => {

									window.location.reload();
									
								}, 3000);

							

							}else{
								

								Swal.fire({
									icon: 'error',
									title: 'Oops...',
									text: data.infoWs
								  })
								  
								  $(this).removeClass('disabled');
								$('.imgSpinner').addClass('hide');


							}

					}, error: function( d,x,v ) {
						
				
						console.log(d);
						console.log(x);
						console.log(v);
						
					}
				});
					
				  })
				  
			  },
			  allowOutsideClick: () => !Swal.isLoading()
		}).then((result) =>{

			if( result.isConfirmed ) {

	
					$(this).removeClass('disabled');
					

				
				

			} else {
	
					$(this).removeClass('disabled');
					$('.imgSpinner').addClass('hide');

				

			}

		}); 

		
	
}

});


	/**=========================================================================================================================
	  *Transmisión de orden se desarrollo en el archivo ubifact.js en js nativo para no afectar los elementos del grid de ordenes.
	=============================================================================================================================*/

		
	
	 /* Ejecutamos el evento click en el boton de Transmitir Orden al Fact*/
	  
	
	 $(document).on( 'click', '[btn-transmitir]', function(e){
				 e.preventDefault();
				 console.log('click');
 
				 //createDraft(createDraftButton);
				 let orderId = parseInt($(this).attr('data-order-id'));
				 let metodoPago = $(this).attr('metodo-pago');
				 let servicio = $(this).attr('servicio');
				 let peso = $(this).attr('peso');
				 if(!servicio){servicio = "1";}
				 if(peso == "" || peso == 0 ){peso = 1;}

				 let idRemi = $(this).attr('remitente');
				//console.log(idRemi.length);
				let nombreRemi = $(this).attr('nombre');
				 
				 //console.log(url_ajax);
				 var html;
 
				 
 
				 if(metodoPago == 'Pago contra reembolso' || metodoPago == 'Pago contra reembolso con comisión'){
 
					html = '<img src="'+baseDir+'modules/sendingbay/views/img/sb-black.png" style="margin: -10px 9px;border-radius: 49%;" width="62px" /><br><br><form action="" method="post" form-fact><table id="mdlTransmicion" style="padding:5px; margin: 0px; width:100%">'+
					'<tr><td colspan="2"><label for="sltRemitente" style="font-size: 1rem; color: #9e9e9e;" class="active">Remitente Predeterminado</label><br><select data-sender="" id="sltRemi"  style="width:100%;" value="'+idRemi+'" class="myform-control form-control sltRemitente"><option value="'+idRemi+'" selected="">'+nombreRemi+'</option></select></td>'+
					'<tr><td><input chk-servicio="" type="checkbox"  id="chkServicio" class="chkServicio"><label for="servicio" style="font-size: 1rem; color: #9e9e9e;" class="active">&nbsp Servicio</label><br><input type="text"  name="servicio" class="servicio1" style="display:none" value="'+servicio+'"/><select data-service="" id="servicio" style="width:100%;" value="'+servicio+'" class="myform-control form-control servicio"><option value="'+servicio+'" selected="">'+servicio+'</option></select></td>'+
					'<td><label for="bultos" style="font-size: 1rem; color: #9e9e9e;" class="active">Bultos</label><input type="text" id="bultos" value="1" class="myform-control form-control validate"></td></tr>'+
					'<tr><td><label for="peso" style="font-size: 1rem; color: #9e9e9e;" class="active">Peso</label><input type="text" id="peso" value="'+peso+'" class="myform-control form-control validate"></td>'+
					'<td><label for="alto" style="font-size: 1rem; color: #9e9e9e;" class="active">Alto</label><input type="text" id="alto" value="1" class="myform-control form-control validate"></td></tr>'+
					'<tr><td><label for="ancho" style="font-size: 1rem; color: #9e9e9e;" class="active">Ancho</label><input type="text" id="ancho" value="1" class="myform-control form-control validate"></td>'+
					'<td><label for="largo" style="font-size: 1rem; color: #9e9e9e;" class="active">Largo</label><input type="text" id="largo" value="1" class="myform-control form-control validate"></td></tr>'+
					'<tr><td colspan="2"><label style="font-size: small;"> <input type="checkbox" checked id="chkPortes" class="portesD">&nbsp Incluir costo del envío </td></tr>'+
					//'<tr><td colspan="2"><label style="font-size: small;">&nbsp&nbsp <input type="checkbox" id="chkDebido" class="debidoP">&nbsp Incluir Portes Debido &nbsp&nbsp </td></tr>'+					
					'</table></form>';
				}else{

					html = '<img src="'+baseDir+'modules/sendingbay/views/img/sb-black.png" style="margin: -10px 9px;border-radius: 49%;" width="62px" /><br><br><form action="" method="post" form-fact><table id="mdlTransmicion" style="padding:5px; margin: 0px; width:100%">'+
					'<tr><td colspan="2"><label for="sltRemitente" style="font-size: 1rem; color: #9e9e9e;" class="active">Remitente Predeterminado</label><br><select data-sender="" id="sltRemi"  style="width:100%;" value="'+idRemi+'" class="myform-control form-control sltRemitente"><option value="'+idRemi+'" selected="">'+nombreRemi+'</option></select></td>'+
					'<tr><td><input chk-servicio="" type="checkbox"  id="chkServicio" class="chkServicio"><label for="servicio" style="font-size: 1rem; color: #9e9e9e;" class="active">&nbsp Servicio</label><br><input type="text"  name="servicio" class="servicio1" style="display:none" value="'+servicio+'"/><select data-service="" id="servicio" style="width:100%;" value="'+servicio+'" class="myform-control form-control servicio"><option value="'+servicio+'" selected="">'+servicio+'</option></select></td>'+
					'<td><label for="bultos" style="font-size: 1rem; color: #9e9e9e;" class="active">Bultos</label><input type="text" id="bultos" value="1" class="myform-control form-control validate"></td></tr>'+
					'<tr><td><label for="peso" style="font-size: 1rem; color: #9e9e9e;" class="active">Peso</label><input type="text" id="peso" value="'+peso+'" class="myform-control form-control validate"></td>'+
					'<td><label for="alto" style="font-size: 1rem; color: #9e9e9e;" class="active">Alto</label><input type="text" id="alto" value="1" class="myform-control form-control validate"></td></tr>'+
					'<tr><td><label for="ancho" style="font-size: 1rem; color: #9e9e9e;" class="active">Ancho</label><input type="text" id="ancho" value="1" class="myform-control form-control validate"></td>'+
					'<td><label for="largo" style="font-size: 1rem; color: #9e9e9e;" class="active">Largo</label><input type="text" id="largo" value="1" class="myform-control form-control validate"></td></tr>'+
					'</table></form>';
				}
 
				 $('.btnTransmitir').addClass('disabled');
				// $('.btn-transmitir i').addClass('fa fa-spinner fa-spin');
				//$('.imgSpinner').removeClass('hide');
 
				
 
				 if(orderId != ""){
 
					 Swal.fire({
						 title				: "Transmitir Pedido",
						 text				: 'Confirma los datos',
						 html				: html,
						 //icon                : "question",
						 showCancelButton    : true,
						 confirmButtonText   : "Generar Etiqueta",
						 closeOnConfirm      : true,
						 showLoaderOnConfirm : true,
						 preConfirm: () => {
							 return fetch('')
							   .then(response => {
 
							 var servicio;
							 var bultos;
							 var peso;
							 var alto ;
							 var ancho;
							 var largo ;
							 var portes = false;
							 var debido = false;
							 var parserito = $('#sltRemi').val();
							
							if(parserito.length > 5){
								console.log(parserito.length);
								parserito = JSON.parse($('#sltRemi').val());
								$('#sltRemi').val()!= "" ? idRemi = parserito.id : idRemi = '';
								//console.log('remitente', idRemi);
							}else{
								$('#sltRemi').val()!= "" ? idRemi = $('#sltRemi').val() : idRemi = '';
							}

							if($(".chkServicio:checked").val() == "on"){

								$('.servicio1').val() != "" ? servicio = $('.servicio1').val() : servicio = '1';

							}else{

								$('#servicio').val() != "" ? servicio = $('#servicio').val() : servicio = '1';

							}

							 
							 $('#bultos').val() != "" ? bultos = $('#bultos').val() : bultos = 0;
							 $('#peso').val() != "" ? peso = $('#peso').val() : peso = 0;
							 $('#alto').val() != "" ? alto = $('#alto').val() : alto = 0;
							 $('#ancho').val() != "" ? ancho = $('#ancho').val() : ancho = 0;
							 $('#largo').val() != "" ? largo = $('#largo').val() : largo = 0;
							 $("#chkPortes:checked").val() == "on" ? portes = "true" : portes = "false";
							// $("#chkDebido:checked").val() == "on" ? debido = "true" : debido = "false";
							 //console.log('check', portes);
 
								 
			 
							 $.ajax({
 
								 url: baseDir + 'modules/sendingbay/ajax.php',
								 type: 'POST',
								 dataType: 'json',
								 data: {
				 
									 action: 'sendAction',
									 servicio: servicio,
									 bultos: bultos,
									 pes: peso,
									 alt: alto,
									 anch: ancho,
									 larg: largo,
									 portes: portes,
									 debido: debido,
									 order: orderId,
									 idsender: idRemi
								 }, success: function( data ){
													 
 
										 if(data.infoWs == 'OK'){
 
											console.log('parametros', data.param);
											console.log('delivery', data.delivery_details);
											console.log('order', data.order_details);
										

											 Swal.fire({
												 title   : 'Transmisión al Fact',
												 text    : 'La Orden: ' + data.idOrden + ' ha sido grabada correctamente en FACT con el numero de Albaran: '+ data.albaran +'',
												 icon    : 'success',
												 timer   : 5000
											 });
											 
											 //location.href = url3;
 
										 setTimeout(function(){
				 
											$('#print-' + data.idOrden).html("<center><span  data-fact-id-label='" + data.albaran + "'  class='btn btn-default labelfact'><i class='icon-print'></i></a></span></center>");
											$('#sel-' + data.idOrden).html("<center><i style='color:green' class='icon-check'></i></center>");
											$('.btnTransmitir').removeClass('disabled');
											 
										 },1000);
 
										 }else{

											//console.log('delivery', data.delivery_details);
 
				 
											 $('.btnTransmitir').removeClass('disabled');
											 //$('.imgSpinner').addClass('hide');
 
											 Swal.fire({
												 icon: 'error',
												 title: 'Oops...',
												 text: data.infoWs
											   });
											   
 
 
										 }

 
								 }, error: function( d,x,v ) {
							 
									 console.log(d);
									 console.log(x);
									 console.log(v);
									 $('.btnTransmitir').removeClass('disabled');
									 
									 
								 }
							 });
								 
							   })
							   
						   },
						   allowOutsideClick: () => !Swal.isLoading()
					 }).then((result) =>{
			 
						 if( result.isConfirmed ) {
 
							 //$('#codigo').addClass('invalid')
							 
			 
						 } else {
			 
							 $('.btnTransmitir').removeClass('disabled');
							 $('.imgSpinner').addClass('hide');
			 
						 }
						 arrayServicios = null;
						arrayRemitentes = null;
			 
					 }); 
 
					 
				 
			 }
 
			 });
			 
		 
 
		
 
		 //Imprimir Etiqueta desde el listados de ordenes de Prestashop
 
	/*	 $(document).on( 'click', '[albaran]', function(){
 
			 var albaran = $(this).attr('albaran');
			 //console.log('albaran', albaran);
 
			 $(this).addClass('disabled');
			 $(this).removeClass('hide');
			 
			 $.ajax({
				 url: baseDir + 'modules/sendingbay/ajax.php',
				 type: 'POST',
				 dataType: 'json',
				 data : {
					 action: 'printLabel',
					 albaran: albaran,
					 tipo: 'view'
				 }, success: function( data ){
					 
					 // si la respuesta de la accion en db es verdadera
					 if( data.etiqueta){
 
						 //console.log(data.etiqueta);
						 
						 window.open(data.etiqueta);
 
					 }
					 else{
						 Swal.fire({
							 title   : 'Etiqueta',
							 text    : 'Info: ' + data.mensaje + '',
							 type    : 'error',
							 timer   : 3500
						 });
 
					 }
				 }, error: function( d,x,v ) {
				 
					 console.log(d);
					 console.log(x);
					 console.log(v);
					 
				 }
			 }); 
			 
			 setTimeout(function(){
				 
				 $('.btnImprimirPdf').removeClass('disabled');
				 
			 },3000);
			 
		 }); */


 /**=========================================================================================================================
	  *Transmisión masiva se desarrollo en el archivo ubifact.js en js nativo para no afectar los elementos del grid de ordenes.
	=============================================================================================================================*/

 function FactMasive() {

	//console.log(chekarray);

	jQuery(document).ready(function(){
	
	orderId = chekarray;
	metodoPago = '';
	let servicio = '';
	let idRemi = '';
	let albaDesde;
	let albaHasta;

	$('#tranMasive').addClass('disabled');
	$('#tranMasive').html('&nbsp;&nbsp;<img src="'+baseDir+'modules/sendingbay/views/img/loader2.gif" width="20px"/>&nbsp; Procesando... &nbsp;');
	   
	   
	
	//console.log(url_ajax);
	var html;
	
	html = '<img src="'+baseDir+'modules/sendingbay/views/img/sb-black.png" style="margin: -10px 9px;border-radius: 49%;" width="62px" /><br><br><form action="" method="post" form-fact><table id="mdlTransmicion"  style="padding:5px; margin: 0px; width:100%">'+
					'<tr><td colspan=""><label for="sltRemitente" style="font-size: 1rem; color: #9e9e9e;" class="active">Remitente</label><br><select data-sender="" id="sltRemi1"  style="width:100%;" value="'+idRemi+'" class="myform-control form-control sltRemitente"><option value="'+idRemi+'" selected="">Predeterminado</option></select></td>'+
					'<td colspan=""><label for="servicio" style="font-size: 1rem; color: #9e9e9e;" class="active">Servicio</label><br><select data-service="" id="servicio" style="width:100%;" value="'+servicio+'" class="myform-control form-control validate servicio"><option value="'+servicio+'" selected="">Predeterminado</option></select></td></tr>'+
					'<tr><td><label for="bultos" style="font-size: 1rem; color: #9e9e9e;" class="active">Bultos</label><input type="text" id="bultos" value="1" class="myform-control form-control validate"></td>'+
					'<td><label for="alto" style="font-size: 1rem; color: #9e9e9e;" class="active">Alto</label><input type="text" id="alto" value="1" class="myform-control form-control validate"></td></tr>'+
					'<tr><td><label for="ancho" style="font-size: 1rem; color: #9e9e9e;" class="active">Ancho</label><input type="text" id="ancho" value="1" class="myform-control form-control validate"></td>'+
					'<td><label for="largo" style="font-size: 1rem; color: #9e9e9e;" class="active">Largo</label><input type="text" id="largo" value="1" class="myform-control form-control validate"></td></tr>'+	
					'<tr><td colspan="2"><label style="font-size: small;"> <input type="checkbox" checked id="chkPortes" class="portesD">&nbsp Incluir costo del envío </td></tr>'+
					//'<tr><td colspan="2"><label style="font-size: small;">&nbsp&nbsp <input type="checkbox" id="chkDebido" class="debidoP">&nbsp Incluir Portes Debido &nbsp&nbsp </td></tr>'+					
					'</table></form>';
	
					

					Swal.fire({
						title				: "Transmitir los ("+ chekarray.length +") Pedidos seleccionados",
						text				: 'Confirma los datos',
						html				: html,
						//icon                : "question",
						showCancelButton    : true,
						confirmButtonText   : "Trasmitir",
						closeOnConfirm      : true,
						showLoaderOnConfirm : true,
						preConfirm: () => {
							return fetch('')
							  .then(response => {

							

							var servicio;
							var bultos;
							var peso;
							var alto ;
							var ancho;
							var largo ;
							var portes = false;
							var debido = false;
							var parserito = $('#sltRemi1').val();
						   
						   if(parserito.length > 5){
							   console.log(parserito.length);
							   parserito = JSON.parse($('#sltRemi1').val());
							   $('#sltRemi1').val()!= "" ? idRemi = parserito.id : idRemi = '';
							   //console.log('remitente', idRemi);
						   }else{
							   $('#sltRemi1').val()!= "" ? idRemi = $('#sltRemi1').val() : idRemi = '';
						   }

							$('#servicio').val() != "" ? servicio = $('#servicio').val() : servicio = '';
							$('#bultos').val() != "" ? bultos = $('#bultos').val() : bultos = 0;
							$('#peso').val() != "" ? peso = $('#peso').val() : peso = 0;
							$('#alto').val() != "" ? alto = $('#alto').val() : alto = 0;
							$('#ancho').val() != "" ? ancho = $('#ancho').val() : ancho = 0;
							$('#largo').val() != "" ? largo = $('#largo').val() : largo = 0;
							$("#chkPortes:checked").val() == "on" ? portes = "true" : portes = "false";
							//$("#chkDebido:checked").val() == "on" ? debido = "true" : debido = "false";
							//console.log('check', portes);


							$.each(chekarray, function(key,value){

							//console.log(value);
			
							$.ajax({

								url: baseDir + 'modules/sendingbay/ajax.php',
								type: 'POST',
								dataType: 'json',
								data: {
				
									action: 'sendAction',
									servicio: servicio,
									bultos: bultos,
									pes: null,
									alt: alto,
									anch: ancho,
									larg: largo,
									portes: portes,
									debido: debido,
									order: value,
									idsender: idRemi
								}, success: function( data ){

									
													
									if (data.infoWs == 'OK') {

										/*console.log('parametros', data.param);
										console.log('delivery', data.delivery_details);
										console.log('order', data.order_details); */

										albarray.push(data.albaran);

										$('#print-' + data.idOrden).html("<center><span  data-fact-id-label='" + data.albaran + "'  class='btn btn-default labelfact'><i class='icon-print'></i></a></span></center>");
										$('#sel-' + data.idOrden).html("<center><i style='color:green' class='icon-check'></i></center>");

										console.log('chekarray.length', chekarray.length);
										console.log('conta', conta);

										conta++;

										if (chekarray.length == conta) {

											

											/*console.log('arrayOrders.length', arrayOrders.length);
											console.log('conta', conta);
											console.log('albaDesde', albaDesde);
											console.log('albaHasta', albaHasta);*/



												setTimeout(() => {

													if (albarray.length == 1) {
														albaDesde = albarray[0];
														albaHasta = albarray[0];
													} else {
														albaDesde = albarray[0];
														albaHasta = albarray.pop();
													}
													console.log('albarray', albarray);
													console.log('albaDesde', albaDesde);
													console.log('albaHasta', albaHasta);

													$('#btnTranMasive').attr('style', 'display:none;');
													$('#btnPrintMasive').attr('style', 'display:block; text-align-last: end;');
													$('#printMasive').attr('alba-desde-masive', albaDesde);
													$('#printMasive').attr('alba-hasta-masive', albaHasta);

													Swal.fire({
														title: 'Etiquetas Generadas',
														text: 'Transmisión masiva ejecutada correctamente',
														icon: 'success',
														timer: 5000
													});



													$('#tranMasive').removeClass('disabled');
													$('#tranMasive').html('<i class="fa da-send"></i>&nbsp;Generar Etiquetas');

													//window.open(data.etiqueta);


												}, 2000);



											


										}


									} else {

										console.log('Info', data.infoWs);


										$('#tranMasive').removeClass('disabled');
										$('#tranMasive').html('<i class="fa da-send"></i>&nbsp;Generar Etiquetas');
										//$('.imgSpinner').addClass('hide');

										if (data.infoWs != '') {

											/*Swal.fire({
												icon: 'error',
												title: 'Oops...',
												text: 'El pedido ' + value + ' ' + data.infoWs
											}) */

											setTimeout(function () {


												//window.location.reload();

											}, 5000);


										}
									}

								

								}, error: function( d,x,v ) {

									$('#tranMasive').removeClass('disabled');
									$('#tranMasive').html('<i class="fa da-send"></i>&nbsp;Generar Etiquetas');
							
									console.log(d);
									console.log(x);
									console.log(v);
																
								}
							});

						});
								
							  })
							  
						  },
						  allowOutsideClick: () => !Swal.isLoading()
					}).then((result) =>{
			
						if( result.isConfirmed ) {

							//$('#codigo').addClass('invalid')

							var tiempo = chekarray.length.toString() + '000';
							var tiempo1;

							if(tiempo >= '10000'){

								tiempo1 = Math.floor(tiempo / 2);

							} else{

								if(tiempo < '3000'){

									tiempo1 = '3000';

								}else{

									tiempo1 = '5000';
								}
								
								
							}
							

							var html2 ='<center><div class=""><img src="'+baseDir+'modules/sendingbay/views/img/preload.gif"></div></center>';

							setTimeout(function(){

								Swal.fire({
									title    : 'Procesando...',
									html	: html2,
									icon    : 'info',
									timer   : tiempo1
								});
	

							},1000);


							

							
							if(albarray.length == 1){
								albaDesde = albarray[0];
								albaHasta = albarray[0];
							}else{
								albaDesde = albarray[0];
								albaHasta = albarray.pop();
							}
							console.log('albarray', albarray);
							console.log('albaDesde', albaDesde);
							console.log('albaHasta', albaHasta);
							
							if(albaDesde != "" && albaHasta != ""){

								$.ajax({
									url: baseDir + 'modules/sendingbay/ajax.php',
									type: 'POST',
									dataType: 'json',
									data : {
										action: 'printMasive',
										albaDesde: albaDesde,
										albaHasta: albaHasta,
										tipo: 'view'
									}, success: function( data ){					
										
										// si la respuesta de la accion en db es verdadera
										if( data.etiqueta){
											
											window.open(data.etiqueta);
											
											setTimeout(function(){
												$('.masive').removeClass('disabled');
												//$preload.css('display','none');
											},300);
					
										}
										else{
											$('.masive').removeClass('disabled');
											//$('#view_fact_masive').modal('close');
					
											Swal.fire({
												title   : 'Etiqueta',
												text    : 'Info: ' + data.error + '',
												type    : 'error',
												timer   : 3500
											});
					
										}
									}, error: function( d,x,v ) {
									
										console.log(d);
										console.log(x);
										console.log(v);
										
									}
								});

							}
	



							
			
						} else {
			 
							$('#tranMasive').removeClass('disabled');
							$('#tranMasive').html('<i class="fa da-send"></i>&nbsp;Generar Etiquetas');
			
						} 

						arrayServicios = null;
						arrayRemitentes = null;
			
					});
					
				
			});
} 

	/**=========================================================================================================================
	  *Esra Función se desarrollo en el archivo ubifact.js en js nativo para no afectar los elementos del grid de ordenes.
	=============================================================================================================================*/
	
	/**
* Ejecutamos el evento click en cada checkbox  para agregar el enlace de transmision masiva
*/
/*$('.noborder').on('click', function() {
 

	  chekarray = [];

	  $('.noborder:checked').each(
		  function() {
			  chekarray.push($(this,":checked").val())					
		  }
	  );

	  console.log('dentro', chekarray);

	  if(chekarray.length > 0){

		if ($('#tranMasive').length) {
			// si existe
		  } else {

			$( '<a id="tranMasive" class="tranMasive btn btn-primary  pointer" style="margin-left: 10px;" onclick="FactMasive();"  ><i class="icon-send"></i>&nbsp;Generar Masivamente</a>' ).insertAfter( "#bulk_action_menu_order" );
			//$('.dropdown-menu').append('<li><a id="tranMasive" class="tranMasive pointer" onclick="FactMasive();"  ><i class="icon-send"></i>&nbsp;Transmitir Masivamente</a></li>');
		  }
		

	  }else if(chekarray.length < 1){

		$('.tranMasive').remove();
	  }

	  //console.log('dentro', chekarray.length);
	  

});

$('.js-bulk-action-checkbox').on('click', function() {

  
		chekarray = [];
  
		$('.js-bulk-action-checkbox:checked').each(
			function() {
				chekarray.push($(this,":checked").val())					
			}
		);

		console.log('dentro', chekarray);
  
		if(chekarray.length > 0){
  
		  if ($('#tranMasive').length) {
			  // si existe
			} else {

				$( '<a id="tranMasive" class="tranMasive btn btn-primary  pointer" style="margin-left: 10px;" onclick="FactMasive();"  ><i class="icon-send"></i>&nbsp;Generar Masivamente</a>' ).insertAfter( "#order_grid .js-bulk-actions-btn" );
			  //$('.dropdown-menu').append('<a id="tranMasive" class="tranMasive pointer dropdown-item" onclick="FactMasive();"  ><i class="icon-send"></i>&nbsp;Transmitir Masivamente</a>');
			}
		  
  
		}else if(chekarray.length < 1){
  
		  $('.tranMasive').remove();
		}
  
  
  });




$('.dropdown-menu li a').on('click', function() {

  
		chekarray = [];
  
		$('.noborder:checked').each(
			function() {
				chekarray.push($(this,":checked").val())					
			}
		);

		console.log('dentro', chekarray);
  
		if(chekarray.length > 0){

			if ($('#tranMasive').length) {
				// si existe
			  } else {

				$( '<a id="tranMasive" class="tranMasive btn btn-primary  pointer" style="margin-left: 10px;" onclick="FactMasive();"  ><i class="icon-send"></i>&nbsp;Generar Masivamente</a>' ).insertAfter( "#bulk_action_menu_order" );
				//$('.dropdown-menu').append('<li><a id="tranMasive" class="tranMasive pointer" onclick="FactMasive();"  ><i class="icon-send"></i>&nbsp;Transmitir Masivamente</a></li>');
			  }
			
	
		  }else if(chekarray.length < 1){
	
			$('.tranMasive').remove();
		  }
  
		console.log('dentro', chekarray.length);
		
  
  });

$('#order_grid_bulk_action_select_all').on('click', function() {
	
  
		chekarray = [];

		setTimeout(function(){

		$('.js-bulk-action-checkbox:checked').each(
			function() {
				chekarray.push($(this,":checked").val())					
			}
		);
		

		console.log('dentro', chekarray);

		if(chekarray.length > 0){
  
		  if ($('#tranMasive').length) {
			  // si existe
			} else {
				$( '<a id="tranMasive" class="tranMasive btn btn-primary  pointer" style="margin-left: 10px;" onclick="FactMasive();"  ><i class="icon-send"></i>&nbsp;Generar Masivamente</a>' ).insertAfter( "#order_grid .js-bulk-actions-btn" );
			  //$('.dropdown-menu').append('<a id="tranMasive" class="tranMasive pointer dropdown-item" onclick="FactMasive();"  ><i class="icon-send"></i>&nbsp;Transmitir Masivamente</a>');
			}
		  
  
		}else if(chekarray.length < 1){
  
		  $('.tranMasive').remove();
		}

		},2000);
  
				
  
  
  });*/